;;;-------------------------------------------------------------------------
;;; File HE        HELP Command                                     12/01/81
;;;-------------------------------------------------------------------------
;;; HELP  COMMAND
;;;  PRINT: REGISTERS AND COMMANDS IN TABLES

HECMD    LEA     MSG002(PC),A5
         BSR     FIXDATA
         BSR     OUT1CR         	; PRINT

         LEA     SOLIST(PC),A4  	; A4 = POINTER TO COMMAND LIST

         BSR     FIXBUF
         MOVE.B  #8,D2          	; D2 = # CMDS PER LINE
HELP4    MOVE.W  (A4)+,D1       	; GET 2 BYTE COMMAND
         CMPI.W  #$FFFF,D1
         BEQ.S   HELP6          	; DONE PRINT LAST BUFFER
         ADDQ.L  #2,A4          	; BUMP POINTER UP BY 2
         TST.W   D1             	; IS THE INVISIBLE INDICATOR ON?
         BMI     HELP4          	; YES... THEN BYPASS THIS ONE
         MOVE.W  D1,D3          	; SAVE XX FOR "XX" AND "NOXX" IN HELP
         ANDI.W  #$7F7F,D1      	; REMOVE CONTROL BITS
         MOVE.W  D1,(A6)+       	; NO.... MOVE THIS COMMAND TO "PRINT" LINE
         MOVE.L  #'    ',(A6)+  	; MOVE BLANKS FOR SPACING
         BSR.S   HELP81         	; PRINT THE LINE IF FULL
         BTST    #7,D3          	; IS "NO" OPTION SUPPORTED?
         BEQ.S   EOHLOOP        	; NO...BYPASS THIS COMMAND, ELSE...
         MOVE.W  #'NO',(A6)+    	; "NO  "   IN MSG
         ANDI.W  #$7F7F,D3      	; RESET CONTROL BITS
         MOVE.W  D3,(A6)+       	; "NOCC"   IN MSG (WHERE CC=COMMAND CODE)
         MOVE.W  #'  ',(A6)+    	; "NOCC  " IN MSG    "    "    "      "
         BSR.S   HELP81         	; PRINT THE LINE IF FULL
EOHLOOP  BRA     HELP4          	; NEXT COMMAND.

;;;        DISPLAY LINE OF COMMANDS (IF FULL)

HELP81   SUBQ.B  #1,D2          	; D2 = COUNT OF COMMANDS PER LINE
         BNE.S   HELP85         	; NOT FULL, JUST RETURN FOR MORE
         BSR     OUT1CR         	; YES, THEN WRITE IT
         BSR     FIXBUF         	; SET-UP LINE FOR NEXT COMMANDS
         MOVE.B  #8,D2          	; D2 = MAX NUMBER CAN BE PLACED IN LINE
HELP85   RTS

HELP6    BSR     OUT1CR         	; PRINT ANY REMAINING PORTION
;        BRA     HELP1          	; SEE IF COMPLETE
         BRA     MACSBUG        	; HELP IS COMPLETE SO RETURN

MSG002   DC.B    '.PC .SR .US .SS',CR,LF
         DC.B    '.D0 .D1 .D2 .D3 .D4 .D5 .D6 .D7',CR,LF
         DC.B    '.A0 .A1 .A2 .A3 .A4 .A5 .A6 .A7',CR,LF
         DC.B    '.R0 .R1 .R2 .R3 .R4 .R5 .R6',CR,LF,EOT

         DC.B    0              PAD BYTE
